package com.ff.apimngr.service;

import com.alibaba.fastjson.JSON;
import com.ff.apimngr.dao.ApiMapper;
import com.ff.apimngr.entity.Api;
import com.ff.apimngr.entity.TopApi;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.UUID;

@Service
public class ApiService {

    @Resource
    private ApiMapper apiMapper;

    public Api findApiById(Integer id) {
        return apiMapper.findById(id);
    }

    public Api findApiByName(String name) {
        return apiMapper.findByName(name);
    }


    public boolean insertApi(Api api)
    {
        boolean flag = apiMapper.insert(api);
//        System.err.println(JSON.toJSONString(api));
        api= apiMapper.findByName(api.getName());
        String cgiUrl="http://cgi.platomix.net/cgi/"+(UUID.randomUUID().toString().replace("-",""))+"/"+api.getId();
        api.setCgiUrl(cgiUrl);
        api.setDocUrl(cgiUrl);
        apiMapper.update(api);

        return  flag;
    }

    public boolean updateApi(Api api) {
        return apiMapper.update(api);
    }

    public boolean deleteApiById(Integer id) {
        return apiMapper.deleteById(id);
    }

    public List<Api> listApis(String tag, Integer status) {
        return apiMapper.listApis(tag, status);
    }

    public List<Api> listApisByType(Integer apiTypeId) {
        return apiMapper.listApisByType(apiTypeId);
    }

    public List<Api> listApisByTypeAndRole(Integer apiTypeId, Integer roleId) {
        return apiMapper.listApisByTypeAndRole(apiTypeId, roleId);
    }

    public List<Api> listApisByStatusAndRole(String tag, Integer status, Integer roleId) {
        return apiMapper.listApisByStatusAndRole(tag, status, roleId);
    }

    public int getAllApiNum() {
        return apiMapper.getAllApiNum();
    }
    public int getPublishedApiNum() {
        return apiMapper.getPublishedApiNum();
    }
    public int getUnPublishedApiNum() {
        return apiMapper.getUnPublishedApiNum();
    }
    public int getTodayCallNum(Long startTime) {
        return apiMapper.getTodayCallNum(startTime);
    }
    public int getAlarmApiNum() {
        return apiMapper.getAlarmApiNum();
    }
    public int getAbnormalApiNum() {
        return apiMapper.getAbnormalApiNum();
    }
    public List<TopApi> getTopTenApis(String startDate, String endDate) {
        return apiMapper.getTopTenApis(startDate, endDate);
    }
}
